#include <stdlib.h>
#include <stdio.h>
#include "array_backup_stack.h"
#include "array_backup.h"
#include "error_message.h"
#include "profile.h"
#include "memalloc.h"

abs_p abs_new(int dictsize){
  abs_p new;

  prof_event(PROF_ABS_NEW);
  new=memalloc(sizeof(abs_t));
 
  new->top=NULL;
  new->dictsize=dictsize;
  abs_push(new);
  return new;
}

void abs_destroy(abs_p stack){

  while(stack->top){
    abs_pop(stack);
  }
  memfree(stack);
  prof_event(PROF_ABS_DESTROY);
}

void abs_push(abs_p stack){
  array_backup_p new=ab_new(stack->dictsize);

  new->next=stack->top;
  stack->top=new;
}

void abs_pop(abs_p stack){
    array_backup_p dead=stack->top;
    stack->top=stack->top->next;
    ab_destroy(dead);
}  

void abs_set(abs_p stack,int key,int val){
  ab_set(stack->top,key,val);
}

array_backup_p abs_top(abs_p stack){
  return stack->top;
}

void abs_report(abs_p stack){
  array_backup_p cur;
  int fill=0,size=0,count=0;
  for (cur=stack->top; cur; cur=cur->next){
    size+=ab_capacity(cur);
    fill+=ab_fill(cur);
    ab_report(cur);
    count++;
  }
  fprintf(stderr,"total(%d) %d/%d =%03f\n",count,fill,size,
	   (double)fill/size);
}
