#ifndef _PROFILE_H
#define _PROFILE_H
#include <sys/time.h>

typedef enum prof_event_enum { 
  PROF_SUCCESS=0,
  PROF_NODE=1,
  PROF_CREATE_NODE=2,
  PROF_DESTROY_NODE=3,
  PROF_VAR_CHOICE=4,
  PROF_FREE_CHOICE=5,
  PROF_EXTRA_PLUECKER=6,
  PROF_BOUNDARY_FORCED=7,
  PROF_UNBOUNDARY_FORCED=8,
  PROF_RIDGE_CHECK=9,
  PROF_DEPTH_LIMIT=10,
  PROF_NOSAVE=11,
  PROF_ABS_NEW=12,
  PROF_ABS_DESTROY=13
  
} prof_event_t;
#define PROF_NUM_COUNTERS 14


#ifndef DETAILED_PROFILE
#define maybe_prof_event(a) /*NOP*/
#else
#define maybe_prof_event(a) prof_event(a)
#endif

void prof_zram_init(void);
void prof_init(void);
void prof_dump(int level);
void prof_event(int);
int prof_success();
unsigned long int prof_get();
void prof_reset(void);  

#ifdef PROFILE_LABELS
static char * profile_label[]=
{
  "Success",
  "Nodes",
  "Create Node",
  "Destroy Node",
  "Variable Choice",
  "Free Variable Choice",
  "Extra Pluecker checks",
  "Forced Facets",
  "Forced Unfacets",
  "Effective Ridge Checks",
  "Depth Limit Reached",
  "Save Skipped",
  "Array backup stack created",
  "Array backup stack destroyed"
};

#endif


#endif

