/**
 * @file   int_to_symbol.c
 * @author David Bremner <bremner@unb.ca>
 * @date   Fri Dec 27 18:30:37 2002
 * 
 * @brief  convert an integer representing a sign to a symbol
 * 
 * this is the uniform version
 */

#include "error_message.h"
#include "oms_types.h"

char sign2char(int s){
  char c;
    switch (s){
    case -1:
      c='-';
      break;
    case 1:
      c='+';
      break;
    case 0:
      c='?';
      break;
    default:
      err_fatal(HERE,"unknown sign encoding %d",s);
    }
    return c;
}


bool sign_unknown(int s){
  return (s==0);
}

char bdy2char(int b){
  char c;
    switch (b){
    case -1:
      c='-';
      break;
    case 1:
      c='+';
      break;
    case 0:
      c='?';
      break;
    default:
      err_fatal(HERE,"unknown boundary state %d",b);
    }
    return c;
}

char *sign2string(int sigma){
  switch (sigma){
  case 1:
    return "+1";
    break;
  case -1:
    return "-1";
    break;
  case 0:
    return "0";
    break;
  default:
    err_fatal("sign_int","cannot convert sign '%d' to string\n",
	      sigma);
  }
  /*NOTREACHED*/
}
char sign2prefix(int s){
  return sign2char(2);
}
