/* glue to talk to yacc generated parser */


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "parser.h"
#include "globaldef.h"
#include "error_message.h"
#include "runtime_options.h"

#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif

extern FILE *yyin;
static bool first_parse=1;


extern bool parse_input(params_p params){

  if (first_parse)
    parser_init(params);

  ro_set_param_block(params);

  if (yyparse()==1)
    err_fatal(HERE,"error parsing");

  if (parser.empty && first_parse)
    err_fatal(HERE,"empty input");

  if (parser.empty){
    return FALSE;
  }
    

  first_parse=0;


  params->n=parser.elements;
  params->r=parser.rank;

  if ((params->diameter)!=-1 && !(params->uniform))
    err_fatal("nuoms","Diameter constraints only supported for uniform case");

  err_assert(params->n >= params->r+2);

  return TRUE;
}


extern void parser_init(params_p params){
  parser.rank=-1;
  parser.elements=-1;
  parser.empty=0;
#if YYDEBUG
  yydebug=1;
#endif

}


extern void parser_rank(int rank){
  parser.rank=rank;
}

extern void parser_elements(int n){
  parser.elements=n;
}




