/* z_ps.c (ZRAM Procedure Sets)

   Ambros Marzetta
   94-11-10
   
 * $Source$
 * $Revision: 2732 $
 * $Date: 2000-11-15 12:14:52 -0400 (Wed, 15 Nov 2000) $
 * $Log$
 * Revision 1.2  2000/11/15 16:14:52  bremner
 * committing patched version of zram source
 *
 * Revision 1.2  1996/04/09  13:27:45  marzetta
 * detect uninitialized procsets
 *
 * Revision 1.1  1995/07/24  13:55:43  marzetta
 * Initial revision
 *
 */

#include <assert.h>
#include "z_ps.h"

#define MAXPROCSET 30
static z_ProcSetP gprocset[MAXPROCSET];
static unsigned int numProcSet;

z_ProcSetNum z_InstallProcSet(z_ProcSetP procset)
{
  /* Store the address of procset and return a reference number for it. */
  assert(numProcSet < MAXPROCSET);
  gprocset[numProcSet] = procset;
  return (++ numProcSet);
} /* z_InstallProcSet */


z_ProcSetP z_GetProcSet(z_ProcSetNum n)
{
  /* Return the procset with reference number n.
     n == 0 is not allowed in order to detect uninitialized procsets.
     */
  assert(n > 0 && n <= numProcSet);
  return gprocset[n-1];
} /* z_GetProcSet */
