/* -*- C -*- */
%{

#include <stdio.h>
#include "zconf.h"
  
  extern int lineno;

  int current_proc,num_procs;

  extern zconf_p z_conf;
  zconf_proc_p zn;
  
  static zconf_p newConf(int);

%}

%union {
char string[STRSIZ];
int integer;
}

%token <string> LBRACE RBRACE EQUALS SEMI PROC SEQ
%token  NUM_PROCS VERSION SENTINEL
%token <string>  CHECKPOINT 
%token <string> ARCH GLOBAL STRING
%token <integer> INT

%%

conf_file:  NUM_PROCS opt_eq INT {z_conf=newConf($3);} 
gparam_list section_list;

gparam_list: /* empty */
	| gparam_list gparam_pair ;

gparam_pair:  VERSION opt_eq INT {z_conf->file_version=$3;}
	| SEQ opt_eq INT {z_conf->seq=$3;}
	| ARCH opt_eq STRING {strncpy(z_conf->arch,$3,STRSIZ);}
| SENTINEL opt_eq INT {z_conf->sentinel=$3;} ;

section_list: /* empty */ | section_list section ;

section: section_header LBRACE parameter_list RBRACE {zn->configured=1;} ;

parameter_list: /* empty */| parameter_list opt_sep parameter_pair ;


section_header: GLOBAL {  zn=&(z_conf->global); } 
		| PROC INT {  zn=z_conf->proc+$2; 
		fprintf(stderr,"reading params for node %d\n",$2); } ;

opt_eq: /* empty */ {} | 
EQUALS {} ;
opt_sep: /* empty */ {} | 
SEMI {};

parameter_pair: CHECKPOINT opt_eq STRING { strncpy(zn->checkpoint,$3,STRSIZ); };


%%

static zconf_p newConf(int nodes){
  int i;
  zconf_p zc;

  zc=malloc(sizeof(zconf_t)+(nodes-1)*sizeof(zconf_proc_t));

  zc->global.configured=0;


  zc->numprocs=nodes;
  for (i=0; i<nodes; i++){
    zc->proc[i].configured=0;
  }
  return zc;
}
